﻿using Syncfusion.UI.Xaml.TreeGrid;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Markup;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace TreeGridSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        TreeSampleEntity[] array = {
            new TreeSampleEntity{Key = "1", ParentKey = "0", Name = "One"},
            new TreeSampleEntity{Key = "1.1", ParentKey = "1", Name = "Two"},
            new TreeSampleEntity{Key = "1.2", ParentKey = "1", Name = "Three"},
            new TreeSampleEntity{Key = "1.2.1", ParentKey = "1.2", Name = "Four"},
            new TreeSampleEntity{Key = "2", ParentKey = "0", Name = "Five"},
            new TreeSampleEntity{Key = "3", ParentKey = "0", Name = "Six"}
        };

        public MainPage()
        {
            this.InitializeComponent();

            TreeGrid.TreeGridColumnSizer = new VTreeGridColumSizer(TreeGrid);
            TreeGrid.RequestTreeItems += TreeGrid_RequestTreeItems;
        }

        private void TreeGrid_RequestTreeItems(object sender, TreeGridRequestTreeItemsEventArgs args)
        {
            if (args.ParentItem == null)
            {
                args.ChildItems = array.Where(x => x.ParentKey.Equals("0"));
            }
            else
            {
                TreeSampleEntity item = args.ParentItem as TreeSampleEntity;
                if (item != null)
                    args.ChildItems = array.Where(x => x.ParentKey.Equals(item.Key));
            }
        }

        public class TreeSampleEntity
        {
            public string Key { get; set; }
            public string ParentKey { get; set; }
            public string Name { get; set; }

        }
    }
}
