﻿using Syncfusion.UI.Xaml.TreeGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using Windows.System;

namespace TreeGridSample
{
    public class VTreeGridColumSizer : TreeGridColumnSizer
    {
        public VTreeGridColumSizer(SfTreeGrid grid) : base(grid)
        {
        }
        
        //Overriding SetStarWidth method
        protected override void SetStarWidth(double remainingColumnWidth, IEnumerable<TreeGridColumn> remainingColumns)
        {
            var removedColumn = new List<TreeGridColumn>();
            var columns = remainingColumns.ToList();
            TreeGridColumn fillColumn = null;
            double expanderColumnWidth = TreeGrid.View != null ? ((TreeGrid.View.Nodes.MaxLevel + 1) * ExpanderWidth + 2) : 0;
            if (TreeGrid.ShowCheckBox)
                expanderColumnWidth += CheckBoxWidth + 1;
            var totalRemainingStarValue = remainingColumnWidth;

            double removedWidth = 0;
            bool isremoved;
            while (columns.Count > 0)
            {
                isremoved = false;
                removedWidth = 0;
                double starWidth = Math.Floor((totalRemainingStarValue / columns.Count));
                var column = columns.First();
               
                double columnWidth = 0;
                if (column == GetExpanderColumn())
                {
                    if (columns.Count == 1)
                        columnWidth = expanderColumnWidth + starWidth;
                    else
                        columnWidth = CalculateExpanderColumnWidth(column, starWidth);
                }
                else
                    columnWidth = starWidth;
                double computedWidth = SetColumnWidth(column, columnWidth);
                if (starWidth != computedWidth && starWidth > 0)
                {
                    isremoved = true;
                    columns.Remove(column);
                    foreach (var remColumn in removedColumn)
                    {
                        if (!columns.Contains(remColumn))
                        {
                            removedWidth += remColumn.ActualWidth;
                            if (remColumn == GetExpanderColumn())
                                removedWidth -= expanderColumnWidth;
                            columns.Add(remColumn);
                        }
                    }
                    removedColumn.Clear();
                    totalRemainingStarValue += removedWidth;
                }

                totalRemainingStarValue = totalRemainingStarValue - computedWidth;
                if (column == GetExpanderColumn())
                    totalRemainingStarValue = totalRemainingStarValue + expanderColumnWidth;
                if (!isremoved)
                {
                    columns.Remove(column);
                    if (!removedColumn.Contains(column))
                        removedColumn.Add(column);
                }
            }

            if (fillColumn != null)
            {
                double columnWidth = 0;
                var lastColumn = fillColumn;              
                if (lastColumn == GetExpanderColumn())
                    totalRemainingStarValue += expanderColumnWidth;
                if (totalRemainingStarValue < columnWidth)
                    SetColumnWidth(fillColumn, columnWidth);
                else
                    SetColumnWidth(fillColumn, totalRemainingStarValue);
            }

        }
    }
}